#include <Adafruit_CircuitPlayground.h>

#define ROTATION_RATE   100  // Time delay between color changes
#define NUM_PIXELS      10   // Number of LEDs

int readValue = 0;
int readValue2 = 0;
int readValue3 = 0;
int readValue4 = 0;
int calibrate = 150; // Touch threshold
int brightness = 100;
int speed = 20;
int red = 6;
int green = 120;
int blue = 250;
int redSpeed = 10;
int greenSpeed = 10;
int blueSpeed = 10;
int pixelNum = 0;
uint32_t colors[] = {
  0xEA2B1F, 0xFF5714, 0xFDCA40, 0x9CEC5B, 0x0CF574,
  0x1BE7FF, 0x3772FF, 0x5A0B4D, 0xFF82A9, 0xD81E5B
};

int startIndex = 0;
unsigned long lastUpdateTime = 0;

void setup() {
  CircuitPlayground.begin();
  CircuitPlayground.setBrightness(150);
  Serial.begin(9600);  // Start Serial Monitor
  setAllWhite();  // Start with all LEDs white
}

void loop() {
  // 1346
  readValue = CircuitPlayground.readCap(A4);
  readValue2 = CircuitPlayground.readCap(A6);
  readValue3 = CircuitPlayground.readCap(A1);
  Serial.print("rainbow: ");  // Print touch value
  Serial.print(readValue);
  Serial.print(", colorShift: ");  // Print touch value
  Serial.print(readValue3);
  Serial.print(", brightness: ");
  Serial.println(readValue2);

  if (readValue > calibrate) {  // If touching A1, rotate rainbow
    if (millis() - lastUpdateTime >= ROTATION_RATE) {
      lastUpdateTime = millis();  // Reset timer
      rotateRainbow();
    }
  } else if (readValue2 > readValue && readValue2 > readValue3 && readValue2 > readValue4 && readValue2 > calibrate) {
    if (millis() - lastUpdateTime >= ROTATION_RATE) {
      lastUpdateTime = millis();  // Reset timer
      pulsate();
    }
  } else if (readValue3 > readValue2 && readValue3 > readValue && readValue3 > readValue4 && readValue3 > calibrate) {
    if (millis() - lastUpdateTime >= ROTATION_RATE) {
      lastUpdateTime = millis();  // Reset timer
      colorShift();
    }
  
  } else {  
    setAllWhite();  // If not touching, reset to white
  }
}

// Function to set all LEDs to white
void setAllWhite() {
  for (int i = 0; i < NUM_PIXELS; i++) {
    CircuitPlayground.setPixelColor(i, 255, 255, 255);  // White
  }
}

// Function to rotate the rainbow effect
void rotateRainbow() {
  CircuitPlayground.clearPixels();
  int colorIndex = startIndex;
  for (int i = 0; i < NUM_PIXELS; i++) {
    CircuitPlayground.setPixelColor(i, colors[colorIndex]);
    colorIndex = (colorIndex + 1) % NUM_PIXELS;  // Wrap around
  }
  startIndex = (startIndex + 1) % NUM_PIXELS;
}
void pulsate(){
  if(brightness + speed > 255 || brightness + speed < 5){
    speed = speed * -1;
  }
  brightness = brightness + speed;
  CircuitPlayground.setBrightness(brightness);
 for (int i = 0; i < NUM_PIXELS; i++){
  CircuitPlayground.setPixelColor(i, 255, 255, 255);
 }
}

void colorShift(){
  if(red + redSpeed > 255 || red + redSpeed < 5){
    redSpeed = redSpeed * -1;
  }
  if(green + greenSpeed > 255 || green + greenSpeed < 5){
    greenSpeed = greenSpeed * -1;
  }
  if(blue + blueSpeed > 255 || blue + blueSpeed < 5){
    blueSpeed = blueSpeed * -1;
  }

  red = red + redSpeed;
  blue = blue + blueSpeed;
  green = green + greenSpeed;

  // Serial.print("Red: ");
  // Serial.print(red);
  // Serial.print(", Green: ");
  // Serial.print(green);
  // Serial.print(", Blue: ");
  // Serial.println(blue);

  for (int i = 0; i < NUM_PIXELS; i++){
  CircuitPlayground.setPixelColor(i, red, green, blue);
 }
}